<?php
/**
 * @version		$Id: local_jail_servers.php,v 1.1 2010/05/10 10:31:05 juanca Exp $
 * @package		vpl. full description form definition
 * @copyright	Copyright (C) 2010 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/
require_once dirname(__FILE__).'/../../../config.php';
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once $CFG->libdir.'/formslib.php';

class mod_vpl_setjails_form extends moodleform {
	function definition(){
		$mform    =& $this->_form;    
        $mform->addElement('header', 'headersetjails', get_string('local_jail_servers', VPL));
        $mform->addElement('hidden','id',required_param('id',PARAM_INT));
        $mform->addElement('textarea', 'jailservers', get_string('jail_servers_description', VPL), array('cols'=>60, 'rows'=>10, 'wrap'=>'off'));
        $mform->setType('jailservers', PARAM_RAW);
        $this->add_action_buttons();
	}
}
$id = required_param('id',PARAM_INT);
$vpl = new mod_vpl($id);
$vpl->require_capability(VPL_SETJAILS_CAPABILITY);
$mform = new mod_vpl_setjails_form('local_jail_servers.php');
//Display page
$course = $vpl->get_course();
$vpl->print_header(get_string('local_jail_servers',VPL));
$vpl->print_heading_with_help('local_jail_servers');
$vpl->print_configure_tabs(basename(__FILE__));
$link = vpl_rel_url('local_jail_servers.php','id',$id);
if ($mform->is_cancelled()){
	redirect($link);
} else if ($fromform=$mform->get_data()){
	if(isset($fromform->jailservers)){
		$vpl->add_to_log('set jails',vpl_rel_url('forms/local_jail_servers.php','id',$id));
		$instance = $vpl->get_instance();
		$instance->jailservers=s($fromform->jailservers);
		if(update_record(VPL,$instance)){
			notice(get_string('saved',VPL),$link);
		}
		else{
			error(get_string('notsaved',VPL),$link);
		}
	}
	else{
		error(get_string('notsaved',VPL));
		vpl_redirect($link);
	}
} else {
	// this branch is executed if the form is submitted but the data doesn't validate and the form should be redisplayed
	// or on the first display of the form.
	$data = new stdClass();
	$data->id = $id;
	$data->jailservers = $vpl->get_instance()->jailservers;
	$mform->set_data($data);
	$vpl->add_to_log('edit jails',$link);
	$mform->display();
}
$vpl->print_footer();

?>