<?php 
/**
 * @version		$Id: statistics.class.php,v 1.1 2010/05/14 17:59:49 juanca Exp $
 * @package		vpl. statistics utility class
 * @copyright	Copyright (C) 2010 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

/*
 * Class vpl_statistcs acount for sum, number of items, mean and desviation
 */
class vpl_statistics {
	protected $total;
	protected $current_item_total;
	protected $items;
	protected $sum_xi_2;

	/**
	 * Constructor
	 **/
	function __construct() {
		$this->total = 0;
		$this->current_item_total = 0;
		$this->items = 0;
		$this->sum_xi_2 = 0;
	}

	/**
	 * count a new item element
	 **/
	function count(){
		$this->total++;
		$this->current_item_total++;
	}

	/**
	 * end last item count
	 **/
	function end_count(){
		$this->sum_xi_2 += $this->current_item_total*$this->current_item_total;
		$this->current_item_total=0;
	}

	/**
	 * count a new item
	 **/
	function count_item(){
		$this->items++;
		$this->end_count();
	}
	
	
	/**
	 * get number of items
	 * @return int
	 */
	function get_items(){
		return $this->items;
	}

	/**
	 * get number of items
	 * @return int
	 */
	function get_total(){
		return $this->total;
	}

	/**
	 * get mean
	 * @return int
	 */
	function get_mean(){
		if($this->items>0){
			return $this->total/$this->items;
		}else{
			return 0;
		}
	}

	/**
	 * get standard deviation
	 * @return int
	 */
	function get_deviation(){
		if($this->items>0){
			return sqrt(($this->sum_xi_2/$this->items)-($this->get_mean()*$this->get_mean()));
		}else{
			return 0;
		}
	}

	/**
	 * print all
	 */
	function sprint_all(){
		return sprintf("Total %d, items %d, media %9.2f, desviacion %9.2f",
					$this->total,
					$this->get_items(),
					$this->get_mean(),
					$this->get_deviation());
		//TODO
/*		return 
		s(get_string('sum',VPL,$this->total)).
		s(', ').
		s(get_string('mean',VPL,$this->get_mean())).
		s(', ').
		s(get_string('deviation',VPL,$this->get_deviation()));*/
	}
	/**
	 * print mean and deviation
	 */
	function sprint_mean(){
		s(get_string('mean',VPL,$this->get_mean()));
		s(get_string('deviation',VPL,$this->get_deviation()));
	}
	/**
	 * print percentage
	 */
	function print_percentage($from){
		printf("%5.2f",$this->get_total()/$from*100);
	}
}
?>